###############################################################################
# SplitSplice.pl                                                              #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
# =========================================================================== #
# Mod Name:    Split/Splice Plus v1.6.2 Beta                                  #
#              Modification/Update of Split/Splice                            #
#              Designed to Split/Splice across Categories/Boards              #
# Split/Splice Written by:  BHRA Webmaster (http://www.bhra.org.uk)           #
# Split/Splice Plus Written by:  Kong (http://www.3dxl.com)                   #
###############################################################################

$SplitSplicemod = "Split/Splice Plus v1.8.1 Beta";

$sstxt{'1'} = "Split Topic";
$sstxt{'2'} = "You are not allowed to split this topic...";
$sstxt{'3'} = "Split from";
$sstxt{'4'} = "Use the selection list to choose where to split this thread. The selected reply, and all subsequent replies will be moved to a new thread.";
$sstxt{'5'} = "Off topic replies have been moved to";
$sstxt{'6'} = "This Thread";
$sstxt{'7'} = "by";
$sstxt{'8'} = "There aren't any replies to split!";
$sstxt{'9'} = "You must select where to split the thread!";
$sstxt{'10'} = "Off Topic";
$sstxt{'11'} = "You cannot split topics containing only 1 post.";

$sstxt{'101'} = "Splice Topic";
$sstxt{'102'} = "You are not allowed to splice this topic...";
$sstxt{'103'} = "Splice to";
$sstxt{'103b'} = "Split to";
$sstxt{'104'} = "Use the selection list to choose which thread to move the contents of the current thread to.";
$sstxt{'104a'} = "Use the selection list to choose the board which<br>you wish to move the contents of the current thread to.";
$sstxt{'104b'} = "Use the selection list to choose the board which<br>contains the thread you wish to move the contents of the current thread to.";
$sstxt{'105'} = "The contents of this thread have been moved";
$sstxt{'106'} = "HERE";
$sstxt{'107'} = "by";
$sstxt{'108'} = "Moved";
$sstxt{'109'} = "You must select a destination thread!";

$sstxt{'201'} = "Split/Splice Topic";
$sstxt{'202'} = "You are not allowed to split/splice this topic...";
$sstxt{'203'} = "Split posts";
$sstxt{'204'} = "-= All Posts =-";
$sstxt{'205'} = "Select which posts to move from the current thread. (Hold down the SHIFT or CTRL keys while clicking to select multiple posts.)";
$sstxt{'206'} = "'Moved to...' notice?";
$sstxt{'207'} = "Tick this if you want to add a link to the moved posts in the current thread.";
$sstxt{'208'} = "You must select at least one post to move!";
$sstxt{'209'} = "Reply";
$sstxt{'210'} = "Splice to";
$sstxt{'210a'} = "(Selected Board)";
$sstxt{'210b'} = "(Original Board)";
$sstxt{'210c'} = "Select";
$sstxt{'210d'} = "Select Board";
$sstxt{'210e'} = "Select Thread";
$sstxt{'211'} = "-= New Thread =-";
$sstxt{'212'} = "Select which thread to move the contents of the current thread to.";
$sstxt{'212b'} = "Select the board where you wish to move the contents of the current thread to.";
$sstxt{'213'} = "New Thread Subject";
$sstxt{'214'} = "If you are moving the selected posts to a new thread, you can enter the Subject of the new thread here. (Leave this box blank if you want to use the existing Subject from the first post selected.)";
$sstxt{'215'} = "Submit";
$sstxt{'216'} = "Reset";
$sstxt{'217'} = "You must select a destination thread!";
$sstxt{'218'} = "Are you sure you want to do this?";

###############################################################################

sub Split_Splice {

	if ($FORM{'ss_submit'} eq $sstxt{'215'} || $FORM{'ss_submit'} eq $sstxt{'1'} || $FORM{'ss_submit'} eq $sstxt{'101'} && $FORM{'mode'} ne ""){
			$mode = $FORM{'mode'};
			$postid = $FORM{'postid'};			
			$ssboard = $FORM{'boardid'};
			$board = $INFO{'board'};
			$checked = $FORM{'moved_to'};
			$oldthreadid = $INFO{'thread'};
			$newthreadid = $FORM{'threadid'};
			$newsubject = $FORM{'new_subject'};
			&Split_Splice2($mode,$posts,$ssboard,$board,$checked,$oldthreadid,$newthreadid,$newsubject);}

	if ($action eq "split") {
		if($INFO{'ssboard'} eq "") { $ssboard = $FORM{'boardid'}; }
		else { $ssboard = $INFO{'ssboard'}; }
		$mode = 0;
		$postlist = qq~                    <option value=""></option>\n~;
	} elsif ($action eq "splice") {
		if($INFO{'ssboard'} eq "") { $ssboard = $FORM{'boardid'}; }
		else { $ssboard = $INFO{'ssboard'}; }
		$mode = 1;
		$threadlist = qq~                    <option value=""></option>\n~;
	} elsif ($action eq "split_splice") { 
		if($ss_advanced ne "1") { &fatal_error("$sstxt{'202'}"); }
		$ssboard = $FORM{'boardid'};
		$checked = 1;
		if($FORM{'ss_submit'} eq $sstxt{'210c'}) { $checked = $FORM{'moved_to'} };
		$newsubject = $FORM{'new_subject'};
		if ($FORM{'postid'} eq "all") {$postlist = qq~                    <option value="all" selected>$sstxt{'204'}</option>\n~;}
		else {$postlist = qq~                    <option value="all">$sstxt{'204'}</option>\n~;}
		$threadlist = qq~                    <option value="new">$sstxt{'211'}</option>\n~;
		$mode = 2;
	}

	if ((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error($txt{100 * $mode + 2}); }
	$yytitle = $sstxt{eval {100 * $mode + 1}};

	$curthread = $INFO{'thread'};
	&LoadCensorList;	# Load Censor List

	if($ss_postcharlimit eq "") { $ss_postcharlimit = 40; }
	if($ss_threadcharlimit eq "") { $ss_threadcharlimit = 50; }
	
	if($action ne "splice") { 
		fopen(FILE,"$datadir/$curthread.txt") || &fatal_error("$txt{'23'} $curthread.txt");
		@messages = <FILE>;
		fclose(FILE);
		if ($mode != 2 && $#messages == 0) {&fatal_error("$sstxt{'11'}");}
		for($counter = 0; $counter <= $#messages; $counter++) {
			if ($counter == 0 && $mode != 2) {next;}
			my $t = "0";
			chomp $messages[$counter];
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $messages[$counter]);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			if (length($postmessage) > $ss_postcharlimit) { $postmessage = substr($postmessage, 0, $ss_postcharlimit) . qq~ ...~; }
			@selposts = split (/\, /, $FORM{'postid'});
			foreach (@selposts) {
				if ($_ eq $counter){$postlist .= qq~<option value="$counter" selected>$sstxt{'209'} $counter: $postmessage</option>\n~; $t = 1; last;}}
			unless ($t eq "1") {$postlist .= qq~                    <option value="$counter">$sstxt{'209'} $counter: $postmessage</option>\n~; }
		}
	}

	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		fopen(CAT, "$boardsdir/$curcat.cat");
		@catinfo = <CAT>;
		fclose(CAT);
		$catinfo[1] =~ s/[\n\r]//g;
		$curcatname="$catinfo[0]";
		foreach $curboard (@catinfo) {
			$curboard =~ s/[\n\r]//g;
			fopen(BOARD, "$boardsdir/$curboard.dat");
			@boardinfo = <BOARD>;
			fclose(BOARD);
			chomp @boardinfo;
			$curboardname = $boardinfo[0];
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				if($curboard eq $currentboard && ($ssboard eq "" || $ssboard eq $currentboard)) {
					$curboard =~ s/[\n\r]//g;
					$boardlist .=qq~                    <option value="$curboard" selected>$curboardname $sstxt{'210b'}</option>\n~;
				}
				elsif($curboard eq $currentboard && ($ssboard ne "" && $ssboard ne $currentboard)) {
					$curboard =~ s/[\n\r]//g;
					$boardlist .=qq~                    <option value="$curboard">$curboardname $sstxt{'210b'}</option>\n~;
				}
				elsif($curboard eq $ssboard && $ssboard ne $currentboard) {
					$curboard =~ s/[\n\r]//g;
					$boardlist .=qq~                    <option value="$curboard" selected>$curboardname $sstxt{'210a'}</option>\n~;
				}
				else {
					$curboard =~ s/[\n\r]//g;
					$boardlist .=qq~                    <option value="$curboard">$curboardname</option>\n~;
				}
			}
		}
	}

	if($action ne "split") { 

		if($ssboard ne "") {
			fopen(FILE, "$boardsdir/$ssboard.txt") || &fatal_error("$txt{'23'} $ssboard.txt");
			@oldthreads = <FILE>;
			fclose(FILE);
			foreach $thread_data (@oldthreads) {
				chomp $thread_data;
				($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$thread_data);
				foreach (@censored) {
					($tmpa,$tmpb) = @{$_};
					$msub =~ s~\Q$tmpa\E~$tmpb~gi;
				}
				if (length($msub) > $ss_threadcharlimit) { $msub = substr($msub, 0, $ss_threadcharlimit) . qq~ ...~; }
				if ($mnum ne $curthread) { $threadlist .= qq~                    <option value="$mnum">$msub</option>\n~; }
			}
		} else {
			fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
			@oldthreads = <FILE>;
			fclose(FILE);
			foreach $thread_data (@oldthreads) {
				chomp $thread_data;
				($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$thread_data);
				foreach (@censored) {
					($tmpa,$tmpb) = @{$_};
					$msub =~ s~\Q$tmpa\E~$tmpb~gi;
				}
				if (length($msub) > $ss_threadcharlimit) { $msub = substr($msub, 0, $ss_threadcharlimit) . qq~ ...~; }
				if ($mnum ne $curthread) { $threadlist .= qq~                    <option value="$mnum">$msub</option>\n~; }
			}
		}
	}

	$yymain .= qq~
<form action="$cgi;action=$INFO{'action'};thread=$INFO{'thread'}" method="POST" name="split"><br>
<input type="hidden" name="mode" value="$mode">
<table border="0" width="80%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>~;

	if ($action eq "split") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr>
			<td align="left" width="50%"><img src="$imagesdir/admin_split.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'1'}</b></font></td>
			<td align="right" width="50%"><font size="2" class="text1" color="$color{'titletext'}"><b>$SplitSplicemod</b></font></td>
			</tr>
			</table>
		  </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'104a'}</font><br><br>
            <b>$sstxt{'103b'}:</b> <select name="boardid">
$boardlist
            </select><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'4'}</font><br><br>
            <b>$sstxt{'3'}:</b> <select name="postid">
$postlist
            </select><input type="hidden" name="threadid" value="new"><input type="hidden" name="moved_to" value="1"><input type="hidden" name="new_subject" value=""><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" name="ss_submit" value="$sstxt{'1'}"></font></td>
        </tr>~;

	} elsif ($action eq "splice") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr>
			<td align="left" width="50%"><img src="$imagesdir/admin_splice.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'101'}</b></font></td>
			<td align="right" width="50%"><font size="2" class="text1" color="$color{'titletext'}"><b>$SplitSplicemod</b></font></td>
			</tr>
			</table>
		  </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'104b'}</font><br><br>
	    <input type="hidden" name="ss_submit">
            <b>$sstxt{'103'}:</b> <select name="boardid" onchange="document.split.ss_submit.value='$sstxt{'210c'}'; submit();">
$boardlist
            </select><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'104'}</font><br><br>
            <b>$sstxt{'103'}:</b> <select name="threadid">
$threadlist
            </select><input type="hidden" name="postid" value="all"><input type="hidden" name="moved_to" value="1"><input type="hidden" name="new_subject" value=""><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" value="$sstxt{'101'}" onclick="document.split.ss_submit.value='$sstxt{'101'}';"></font></td>
        </tr>~;

	} elsif ($action eq "split_splice") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr>
			<td align="left" width="50%"><img src="$imagesdir/admin_split_splice.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'201'}</b></font></td>
			<td align="right" width="50%"><font size="2" class="text1" color="$color{'titletext'}"><b>$SplitSplicemod</b></font></td>
			</tr>
			</table>
		  </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <td valign="top" width="30%"><font size="2"><b>$sstxt{'203'}:</b></font></td>
                <td valign="top">
                  <select name="postid" multiple size="5" style="width:100%">
$postlist
                  </select>
                </td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'205'}<br><br></font></td>
              </tr><tr>
                <td width="30%"><font size="2"><b>$sstxt{'206'}</b></font></td>~;

		if($checked == 1) { $yymain .= qq~<td><input type="checkbox" name="moved_to" value="1" checked></td>~; }
		else { $yymain .= qq~<td><input type="checkbox" name="moved_to" value="1"></td>~; }

	$yymain .= qq~
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'207'}<br><br></font></td>
              </tr>
            </table>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <td colspan="2"><font size="2"><b>$sstxt{'210'}...</b></font></td>
              </tr><tr>
                <td colspan="2"><font size="1"><br></font></td>
              </tr><tr>
                <td width="30%"><font size="2"><b>$sstxt{'210d'}:</b></font></td>
                <td><input type="hidden" name="ss_submit">
                  <select name="boardid" style="width:100%" onchange="document.split.ss_submit.value='$sstxt{'210c'}'; submit();">
$boardlist
                  </select>
                </td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'212b'}<br><br></font></td>
              </tr><tr>
                <td width="30%"><font size="2"><b>$sstxt{'210e'}:</b></font></td>
                <td>
                  <select name="threadid" style="width:100%">
$threadlist
                  </select>
                </td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'212'}<br><br></font></td>
              </tr><tr>
                <td width="30%"><font size="2"><b>$sstxt{'213'}</b></font></td>
                <td><input type="text" name="new_subject" size="40" maxlength="50" style="width:100%" value="$newsubject"></td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'214'}<br><br></font></td>
              </tr>
            </table>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" value="$sstxt{'215'}" onclick="document.split.ss_submit.value='$sstxt{'215'}';"> &nbsp; <input type="reset" name="ss_reset" value="$sstxt{'216'}"></font></td>
        </tr>~;

	}

	$yymain .= qq~
      </table>
    </td>
  </tr>
</table>
</form>
<br>~;

	&template;
	exit;
}

###############################################################################

sub Split_Splice2 {

	$ssboard = $FORM{'boardid'};

	$mode = $FORM{'mode'};	# 0 = Split, 1 = Splice, 2 = Split/Slice (Advanced Mode)
	if ((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error($txt{100 * $mode + 2}); }

	$oldthreadid = $INFO{'thread'};
	$newthreadid = $FORM{'threadid'};
	if ($newthreadid eq "") { &fatal_error("$sstxt{'217'}"); }
	if ($FORM{'postid'} eq "") { &fatal_error("$sstxt{'208'}"); }
	if ($FORM{'postid'} =~ /all/) {$postid = "0";} else {$postid = $FORM{'postid'};}
	&fatal_error($txt{'77'}) unless(!$FORM{'new_subject'} || $FORM{'new_subject'} !~ m~\A[\s_.,]+\Z~);

	# Read existing threads.
	fopen(FILE, "$datadir/$oldthreadid.txt") || &fatal_error("$txt{'23'} $oldthreadid.txt");
	@old_messages = <FILE>;
	fclose(FILE);
	fopen(FILE, "$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data");
	@old_thread_data = <FILE>;
	fclose(FILE);

	if ($mode != 2 || $FORM{'postid'} =~ /all/) { 
		for(my $i = $postid + 1; $i < @old_messages; $i++) { $postid .= ", $i"; }
	}

	# Find a valid random ID for new thread.
	if ($FORM{'threadid'} eq "new") { # Thread doesn't exist, find valid ID
		$new_thread = 1;
		$newthreadid = time;
		$i=0;
		if (-e "$datadir/$newthreadid.txt") {
			while (-e "$datadir/$newthreadid$i.txt") { ++$i; }
			$newthreadid = "$newthreadid$i";
		}
		@new_messages = "";
		@new_thread_data = "";
	} else { # Thread exists, load existing messages
		$new_thread = 0;
		fopen(FILE, "$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt");
		@new_messages = <FILE>;
		fclose(FILE);
		fopen(FILE, "$datadir/$newthreadid.data") || &fatal_error("$txt{'23'} $newthreadid.data");
		@new_thread_data = <FILE>;
		fclose(FILE);
	}

#$yymain .= qq~Post id: $postid<br>Thread id: $newthreadid<br>Moved notice: $FORM{'moved_to'}<br>Date Order: $FORM{'date_order'}<br>New Subject: $FORM{'new_subject'}<br>~;
#&template;
#exit;

	# Update current thread.
	$tmp_threadcount = 0;
	$tmp_postcount = 0;
	$tmp_ssthreadcount = 0;
	$tmp_sspostcount = 0;
	$name = $settings[1];
	$email = $settings[2];
	@reply_ids = split(/\, /, $postid);
	foreach $id (@reply_ids) {
		push (@mobile_messages, $old_messages[$id]);
		$old_messages[$id] = "";
		$tmp_sspostcount++;
	}
	$mm = $#mobile_messages;
	$om = $#old_messages;
	($dummy,$msub) = split(/\|/,$yyThreadLine);
	if ($FORM{'moved_to'}) { # leave "moved to..." notice
		($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $tmpstuff) = split(/[\|]/, $mobile_messages[0], 13);
		if($ssboard ne "" && $ssboard ne $currentboard) {
			if ($#mobile_messages == $#old_messages) {
				$moved_notice = qq~$tmpsub|$tmpname|$tmpemail|$tmpdate|$tmpusername|$tmpicon|0|$tmpip|$sstxt{'105'} \[link=$scripturl?board=$ssboard;action=display;num=$newthreadid\]$sstxt{'106'}\[/link\] $sstxt{'107'} $settings[1].||\n~;
			} elsif ($ss_movedtonew eq "1") {
				$moved_notice = qq~Re: $msub|$name|$email|$date|$username|$tmpicon|0|$user_ip|$sstxt{'5'} \[link=$scripturl?board=$ssboard;action=display;num=$newthreadid\]$sstxt{'6'}\[/link\] $sstxt{'7'} $settings[1].||\n~;
			} else {
				$moved_notice = qq~Re: $msub|$name|$email|$tmpdate|$username|$tmpicon|0|$user_ip|$sstxt{'5'} \[link=$scripturl?board=$ssboard;action=display;num=$newthreadid\]$sstxt{'6'}\[/link\] $sstxt{'7'} $settings[1].||\n~;
			}
		} else {
			if ($#mobile_messages == $#old_messages) {
				$moved_notice = qq~$tmpsub|$tmpname|$tmpemail|$tmpdate|$tmpusername|$tmpicon|0|$tmpip|$sstxt{'105'} \[link=$cgi;action=display;num=$newthreadid\]$sstxt{'106'}\[/link\] $sstxt{'107'} $settings[1].||\n~;
			} elsif ($ss_movedtonew eq "1") {
				$moved_notice = qq~Re: $msub|$name|$email|$date|$username|$tmpicon|0|$user_ip|$sstxt{'5'} \[link=$cgi;action=display;num=$newthreadid\]$sstxt{'6'}\[/link\] $sstxt{'7'} $settings[1].||\n~;
			} else {
				$moved_notice = qq~Re: $msub|$name|$email|$tmpdate|$username|$tmpicon|0|$user_ip|$sstxt{'5'} \[link=$cgi;action=display;num=$newthreadid\]$sstxt{'6'}\[/link\] $sstxt{'7'} $settings[1].||\n~;
			}
		}
		push (@old_messages, $moved_notice);
		$tmp_postcount++;
	} elsif ($#mobile_messages == $#old_messages) {# kill old thread
		opendir (MMD,$datadir);
		@contents = grep {/^$oldthreadid\./} readdir(DIR);
		closedir(MMD);
		foreach $file(@contents) {	
			unlink("$datadir/$file");
		}
		$tmp_threadcount--;
	}
	fopen(FILE, ">$datadir/$oldthreadid.txt") || &fatal_error("$txt{'23'} $oldthreadid.txt");
	print FILE @old_messages;
	fclose(FILE);
	if ($FORM{'moved_to'}) { 
		fopen(FILE, "+>$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data");
		print FILE @old_thread_data;
		fclose(FILE);
	}

	# Save new thread.
	if ($new_thread && ($ssboard ne "" || $ssboard ne $currentboard)) {$tmp_ssthreadcount++;}
	if ($new_thread && ($ssboard eq "" || $ssboard eq $currentboard)) {$tmp_threadcount++;}
	if ($FORM{'new_subject'} && $new_thread) {
		&ToHTML($FORM{'new_subject'});
		($tmpsub, $stuff) = split(/[\|]/, $mobile_messages[0], 2);
		$mobile_messages[0] = qq~$FORM{'new_subject'}|$stuff~;;
		
	}
	push (@new_messages, @mobile_messages);
	fopen(FILE, ">$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt");
	print FILE @new_messages;
	fclose(FILE);
	($dummy, $dummy, $dummy, $newlastposttime, $newlastposter, $dummy) = split(/[\|]/, $new_messages[$#new_messages]);
	chomp $new_thread_data[0];
	@tmp_data = split(/\|/, $new_thread_data[0]);
	$tmp_data[1] = $newlastposter;
	$new_thread_data[0] = join("|", @tmp_data);
	if ($new_thread_data[1] ne "") {$new_thread_data[0] .= "\n";}
	fopen(FILE, "+>$datadir/$newthreadid.data") || &fatal_error("$txt{'23'} $newthreadid.txt");
	print FILE @new_thread_data;
	if($ss_rebuildcomp eq "1" && $new_thread_data[1] eq "") {
		if ($ssboard eq "" || $ssboard eq $currentboard) {
			print FILE qq~\n$currentboard\n~;
		} elsif ($ssboard ne "" && $ssboard ne $currentboard) {
			print FILE qq~\n$ssboard\n~;
		}
	}
	fclose(FILE);

	# Update message index.
	if($ssboard ne "" && $ssboard ne $currentboard) {
		fopen(FILE2, "$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
		@threads2 = <FILE2>;
		fclose(FILE2);

		for(my $i = 0; $i < @threads2; $i++) {
			if( $threads2[$i] =~ m~\A$oldthreadid\|~o ) { $OldThreadLine = $threads2[$i]; $OldThreadPosition = $i;}
		}

		$LastThreadPosition = 0;
		if( $OldThreadPosition == 0) { $LastThreadPosition = $OldThreadPosition + 1;}
		$LastThreadLine = $threads2[$LastThreadPosition];
		($lastnum, $lastsub, $lastname, $lastemail, $lastdate, $lastreplies, $lastusername, $lasticon, $laststate, $laststuff) = split(/\|/, $LastThreadLine, 10);

		if($lastnum ne "") {
			fopen(FILE, "$datadir/$lastnum.data") || &fatal_error("$txt{'23'} $lastnum.data");
			@last_thread_data = <FILE>;
			chomp $last_thread_data[0];
			@tmp_data = split(/\|/, $last_thread_data[0]);
			$lastthreadposter = $tmp_data[1];
			fclose(FILE);
		}

		fopen(FILE2, "$boardsdir/$ssboard.txt") || &fatal_error("$txt{'23'} $ssboard.txt");
	} else {
		fopen(FILE2, "$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
	}
	@threads = <FILE2>;
	fclose(FILE2);

	for(my $i = 0; $i < @threads; $i++) {
		if( $threads[$i] =~ m~\A$newthreadid\|~o ) { $NewThreadLine = $threads[$i]; $NewThreadPosition = $i;}
		if( $threads[$i] =~ m~\A$oldthreadid\|~o ) { $OldThreadLine = $threads[$i]; $OldThreadPosition = $i;}
	}

	@tmp_messages = split(/\n/, join('', @old_messages));
	chomp $OldThreadLine;
	($oldsub, $oldname, $oldemail, $dummy, $oldusername, $oldicon, $oldattach, $oldip, $oldmessage, $oldns, $oldlm, $oldlmb, $dummy) = split(/[\|]/, $tmp_messages[0], 13);
	($dummy, $dummy, $dummy, $olddate, $oldposter) = split(/[\|]/, $tmp_messages[$#tmp_messages]);
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $mstuff) = split(/\|/, $OldThreadLine, 10);
	if ($mstuff ne "") {$mstuff = "|".$mstuff;}
	if ($mm == $om && $checked == 0) {
		$OldThreadLine = qq~~;
	} elsif ($mm == $om && $checked == 1) {
		$OldThreadLine = qq~$oldthreadid|$sstxt{'108'}: $oldsub|$oldname|$oldemail|$newlastposttime|0|$oldusername|$oldicon|1$mstuff\n~;
	} else {
		$OldThreadLine = qq~$oldthreadid|$oldsub|$oldname|$oldemail|$olddate|$#tmp_messages|$oldusername|$oldicon|$mstate$mstuff\n~;
	}

	fopen(FILE, "$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data");
	@old_thread_data = <FILE>;
	fclose(FILE);
	chomp $old_thread_data[0];
	@tmp_data = split(/\|/, $old_thread_data[0]);
	$oldposter2 = $tmp_data[1];
	if ($FORM{'moved_to'} && $mm ne $om) {$tmp_data[1] = $username;}
	elsif ($FORM{'moved_to'} && $mm eq $om) {$tmp_data[1] = $oldposter2;}
	else {$tmp_data[1] = $oldposter;}
	$old_thread_data[0] = join("|", @tmp_data);
	if ($old_thread_data[1] ne "") {$old_thread_data[0] .= "\n";}
	fopen(FILE, "+>$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data");
	print FILE @old_thread_data;
	fclose(FILE);

	@tmp_messages = split(/\n/, join('', @new_messages));
	chomp $NewThreadLine;
	($newsub, $newname, $newemail, $dummy, $newusername, $newicon, $newattach, $newip, $newmessage, $newns, $newlm, $newlmb, $dummy) = split(/[\|]/, $tmp_messages[0], 13);
	($dummy, $dummy, $dummy, $newdate, $dummy) = split(/[\|]/, $tmp_messages[$#tmp_messages]);
	($dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $tmpstate, $tmpstuff) = split(/\|/, $NewThreadLine, 10);
	if ($tmpstate eq "") {$tmpstate = $mstate;}
	if ($tmpstuff ne "") {$tmpstuff = "|".$tmpstuff;}
	$NewThreadLine = qq~$newthreadid|$newsub|$newname|$newemail|$newdate|$#tmp_messages|$newusername|$newicon|$tmpstate$tmpstuff\n~;

	fopen(FILE2, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
		seek FILE2, 0, 0;
		my @buffer = <FILE2>;
		truncate FILE2, 0;
		for ($a = 0; $a < @buffer; $a++) {
			if ( $buffer[$a] =~ m~\A$newthreadid\|~o ) { $buffer[$a] = "";}
			if ($FORM{'moved_to'} && $mm ne $om && $ss_movedtonew eq "1") {
				if ( $buffer[$a] =~ m~\A$oldthreadid\|~o ) { $buffer[$a] = "";}
			} else {
				if ( $buffer[$a] =~ m~\A$oldthreadid\|~o ) { $buffer[$a] = "$OldThreadLine";}
			}
		}
		seek FILE2, 0, 0;
		if ($FORM{'moved_to'} && $mm ne $om && $ss_movedtonew eq "1") {
			print FILE2 qq~$OldThreadLine~;
		}
		if($ssboard eq "" || $ssboard eq $currentboard) {
			print FILE2 qq~$NewThreadLine~;
		}
		print FILE2 @buffer;
	fclose(FILE2);

	if($ssboard ne "" && $ssboard ne $currentboard) {
		fopen(FILE2, "+<$boardsdir/$ssboard.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $ssboard.txt");
			seek FILE2, 0, 0;
			my @buffer = <FILE2>;
			truncate FILE2, 0;
			for ($a = 0; $a < @buffer; $a++) {
				if ( $buffer[$a] =~ m~\A$newthreadid\|~o ) { $buffer[$a] = "";}
			}
			seek FILE2, 0, 0;
			print FILE2 qq~$NewThreadLine~;
			print FILE2 @buffer;
		fclose(FILE2);
}

	# Update totals for boards.
	fopen(FILEBOARDGET, "$boardsdir/$currentboard.ttl");
	$tmpa = <FILEBOARDGET>;
	fclose(FILEBOARDGET);
	chomp $tmpa;
	( $threadcount, $messagecount, $lastposttime, $lastposter, $lastthreadid ) = split( /\|/, $tmpa, 5 );
	$threadcount = $threadcount + $tmp_threadcount;
	if($ssboard ne "" && $ssboard ne $currentboard) {
		$messagecount = $messagecount + $tmp_postcount - $tmp_sspostcount;
	} else {
		$messagecount = $messagecount + $tmp_postcount;
	}

	if($ssboard eq "" || $ssboard eq $currentboard) {
		if ($mm == $om) {
			$lastposttime = $newlastposttime;
			$lastposter = $newlastposter; # Spliced posts
			$tmpthreadid = $newthreadid;
		} else {
			if($checked eq "1" && $ss_movedtonew eq "1") {
				$lastposttime = $date;
				$lastposter = $username; # New Post for Moved To notice
				$tmpthreadid = $oldthreadid;
			} else {
				$lastposttime = $newlastposttime;
				$lastposter = $newlastposter; # Spliced posts
				$tmpthreadid = $newthreadid;
			}
		}
	} elsif ($ssboard ne "" && $ssboard ne $currentboard) {
		if ($mm == $om) {
			if ($checked eq "1") {
				$lastposttime = $lastposttime;
				$lastposter = $lastposter; # No changes - Last post still the same
				$tmpthreadid = $lastthreadid;
			} else {
				if ($OldThreadPosition eq "0") {
					$lastposttime = $lastdate;
					$lastposter = $lastthreadposter; # 2nd thread on boardindex
					$tmpthreadid = $lastlastthreadid;
				} else {
					$lastposttime = $lastposttime;
					$lastposter = $lastposter; # Original for no changes
					$tmpthreadid = $lastthreadid;
				}
			}
		} else {
			if ($checked eq "1") {
				if ($ss_movedtonew eq "1") {
					$lastposttime = $date;
					$lastposter = $username; # New Post for Moved To notice
					$tmpthreadid = $oldthreadid;
				} elsif ($OldThreadPosition eq "0") {
					$lastposttime = $olddate;
					$lastposter = $username; # No New Post for Moved To notice - Post with Old Date
					$tmpthreadid = $oldthreadid;
				} else {
					$lastposttime = $lastposttime;
					$lastposter = $lastposter; # Original for no changes
					$tmpthreadid = $lastthreadid;
				}
			} else {
				if ($OldThreadPosition eq "0") {
					$lastposttime = $olddate;
					$lastposter = $oldposter; # Last post in Oldthread
					$tmpthreadid = $oldthreadid;
				} else {
					$lastposttime = $lastposttime;
					$lastposter = $lastposter; # Original for no changes
					$tmpthreadid = $lastthreadid;
				}
			}
		}
	} else {
		$lastposttime = $lastposttime;
		$lastposter = $lastposter; # Original for no changes
		$tmpthreadid = $lastthreadid;
	}

	fopen(FILE, "+>$boardsdir/$currentboard.poster");
	print FILE $lastposter;
	fclose(FILE);

	$tmpa = qq~$threadcount|$messagecount|$lastposttime|$lastposter~;
	if ($lastthreadid) { $tmpa .= qq~|$tmpthreadid~; }
	fopen(FILEBOARDSET, "+>$boardsdir/$currentboard.ttl");
	print FILEBOARDSET $tmpa;
	fclose(FILEBOARDSET);

	#Update totalls for Target Board
	if($ssboard ne "" && $ssboard ne $currentboard) {
		fopen(FILEBOARDGET, "$boardsdir/$ssboard.ttl");
		$tmpa = <FILEBOARDGET>;
		fclose(FILEBOARDGET);
		chomp $tmpa;
		( $ssthreadcount, $ssmessagecount, $lastposttime, $lastposter, $lastthreadid ) = split( /\|/, $tmpa, 5 );
		$ssthreadcount = $ssthreadcount + $tmp_ssthreadcount;
		$ssmessagecount = $ssmessagecount + $tmp_sspostcount;

		$lastposttime = $newlastposttime;
		$lastposter = $newlastposter; # Spliced posts
		$tmpthreadid = $newthreadid;

		fopen(FILE, "+>$boardsdir/$ssboard.poster");
		print FILE $lastposter;
		fclose(FILE);

		$tmpa = qq~$ssthreadcount|$ssmessagecount|$lastposttime|$lastposter~;
		if ($lastthreadid) { $tmpa .= qq~|$tmpthreadid~; }
		fopen(FILEBOARDSET, "+>$boardsdir/$ssboard.ttl");
		print FILEBOARDSET $tmpa;
		fclose(FILEBOARDSET);
	}

	# Update file attachments.
	fopen(AMV, "$vardir/attachments.txt");
	my @attachments = <AMV>;
	fclose(AMV);
	fopen(AMV, ">$vardir/attachments.txt");
	foreach $row(@attachments) {
		chomp $row;
		my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$row);
		if($amthreadid eq $oldthreadid) {
			$tmpreplies = $amreplies;
			$tmpthreadid = $amthreadid;
			for(my $i = 0; $i < @reply_ids; $i++) {
				if ($reply_ids[$i] == $amreplies) {$tmpreplies = $#tmp_messages - $#mobile_messages + $i; $tmpthreadid = $newthreadid; last;}
				if ($reply_ids[$i] < $amreplies) {$tmpreplies--;}				
			}
			print AMV qq~$tmpthreadid|$tmpreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
		} else {
			print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
		}
	}
	fclose(AMV);

	if ($#mobile_messages == $#old_messages) {# kill old thread
		unlink("$datadir/$oldthreadid.txt");
		unlink("$datadir/$oldthreadid.mail");
		unlink("$datadir/$oldthreadid.data");
		unlink("$datadir/$oldthreadid.poll");
		unlink("$datadir/$oldthreadid.polled");
	}

	if($ssboard ne "" && $ssboard ne $currentboard) {
		$yySetLocation = qq~$scripturl?board=$ssboard;action=display;num=$newthreadid~;
	} else {
		$yySetLocation = qq~$scripturl?board=$currentboard;action=display;num=$newthreadid~;
	}
	&redirectexit;

}

1;